using System;
using System.Collections;

namespace ADO.NET
{
	class Client
	{
		[STAThread]
		static void Main(string[] args)
		{            
            try
            {
                StockRecordDAO dao = new StockRecordDAO();

                StockRecord record  = dao.GetStockRecord(1000);
                Console.WriteLine("Reading a single record with ID=1000:  "+record.Ticker);

                ArrayList records = dao.GetStockRecords(38293);            
                Console.WriteLine("There are "+records.Count+" records with ID = 38293");

                Console.WriteLine("Adding a record...");
                StockRecord newRecord = new StockRecord(0,"P",37892,"LUCP",500,46.23);
                dao.AddStockRecord(newRecord);
            }
            catch (StockRecordDAOException srdao)
            {
                Console.WriteLine(srdao.ToString());
            }
		}
	}
}
