import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import CallBackDAO.NotificationRemoting;
import com.intrinsyc.janet.RemoteException;

public class StockRecordDAO
{
   private Connection _conn = null;
   private String CONNECTION_STRING = "jdbc:microsoft:sqlserver://localhost:1433;DatabaseName=SharedDB";
   private String CONNECTION_USERNAME = "testuser";
   private String CONNECTION_PASSWORD = "StrongPassword";
   
   public StockRecordDAO() throws StockRecordDAOException
   {
     try
     {
         Class.forName("com.microsoft.jdbc.sqlserver.SQLServerDriver");
         _conn = DriverManager.getConnection(CONNECTION_STRING,CONNECTION_USERNAME,CONNECTION_PASSWORD);
     }
     catch (java.sql.SQLException sqle)
     {
        throw new StockRecordDAOException("Could not open connection to SQL Server");
     }
     catch (ClassNotFoundException cnfe)
     {
        throw new StockRecordDAOException("Could not find the SQL Server JDBC Classes");
     }
   }
   
   public StockRecord getStockRecord(long ID) throws StockRecordDAOException
   {
      try
      {
          Statement stmt = _conn.createStatement();
          ResultSet rs = stmt.executeQuery("SELECT * FROM ORDERTBL WHERE ID = "+ID);
          
          rs.next();
          return nextRowToRecord(rs);
      }
      catch (java.sql.SQLException sqle)
      {
          throw new StockRecordDAOException(sqle);
      }
   }
   
   public ArrayList getStockRecords(long accountID) throws StockRecordDAOException
   {
        return selectRecords("SELECT * FROM ORDERTBL WHERE ACCOUNT_ID = "+accountID);
   }
   
   public ArrayList getStockRecords(String type, long accountID) throws StockRecordDAOException
   {
        return selectRecords("SELECT * FROM ORDERTBL WHERE TYPE = '"+type+"' AND ACCOUNT_ID = "+accountID);
   }
   
   public ArrayList getStockRecords(String type, String ticker) throws StockRecordDAOException
   {
        return selectRecords("SELECT * FROM ORDERTBL WHERE TYPE ='"+type+"' AND TICKER = '"+ticker+"'");
   }
   
   public ArrayList getStockRecords(long accountID, String ticker) throws StockRecordDAOException
   {
        return selectRecords("SELECT * FROM ORDERTBL WHERE ACCOUNT_ID = "+accountID+" AND TICKER = '"+ticker+"'");
   }
   
   public ArrayList getStockRecords(String type, long accountID, String ticker) throws StockRecordDAOException
   {
        return selectRecords("SELECT * FROM ORDERTBL WHERE TYPE = '"+type+"' AND ACCOUNT_ID = "+accountID+" AND TICKER = '"+ticker+"'");
   } 
   
   public ArrayList getAllStockRecords() throws StockRecordDAOException
   {
        return selectRecords("SELECT * FROM ORDERTBL");
   }

   public void addStockRecord(StockRecord record) throws StockRecordDAOException
   {
        try
        {
            Statement stmt = _conn.createStatement();
            int rowsAffected = stmt.executeUpdate("INSERT ORDERTBL (TYPE,ACCOUNT_ID,TICKER,QTY,PRICE) VALUES ('"+record.Type+"',"+record.AccountID+",'"+record.Ticker+"',"+record.Qty+","+record.Price+")");
            if (rowsAffected != 1) throw new StockRecordDAOException("Add record may have failed");
        }
        catch (SQLException sqle)
        {
            throw new StockRecordDAOException(sqle);
        }
        
        try
        {
            // Send the update via the Remoting channel - you could also imagine how we could pass a record using this mechanism
            // to allow delta-based updates
            NotificationRemoting n = new NotificationRemoting();
            n.Update();
        }
        catch (RemoteException re)
        {
            throw new StockRecordDAOException(re);
        }
            
   }
   
   private ArrayList selectRecords(String selectString) throws StockRecordDAOException
   {
        try
        {
        Statement stmt = _conn.createStatement();
        ResultSet rs = stmt.executeQuery(selectString);
        
        ArrayList records = new ArrayList();
        while (rs.next())
        {
            records.add(nextRowToRecord(rs));   
        }
        
        return records;
        }
        catch (java.sql.SQLException sqle)
        {
            throw new StockRecordDAOException(sqle);
        }
        
        
   }
   
   private StockRecord nextRowToRecord(java.sql.ResultSet rs) throws java.sql.SQLException
   {
      return new StockRecord(rs.getLong(1),rs.getString(2),rs.getLong(3),rs.getString(4),rs.getInt(5),rs.getDouble(6));
   }
}
